function tvRP.spawnVehicle(model, plate) 
    -- load vehicle model
    local i = 0
    local mhash = GetHashKey(model)
    while not HasModelLoaded(mhash) and i < 1000 do
	  	if math.fmod(i,100) == 0 then
	  	  	tvRP.notify("Modelul vehicului se incarca.")
	  	end
      	RequestModel(mhash)
      	Citizen.Wait(30)
	  	i = i + 1
    end

    -- spawn car if model is loaded
    if HasModelLoaded(mhash) then
      	local x,y,z = tvRP.getPosition()
      	local nveh = CreateVehicle(mhash, x,y,z+0.5, GetEntityHeading(_GPED), true, false) -- added player heading
      	SetVehicleOnGroundProperly(nveh)
      	SetEntityInvincible(nveh,false)
      	SetVehicleDirtLevel(nveh,0.0)
      	SetPedIntoVehicle(_GPED,nveh,-1) -- put player inside
      	Citizen.InvokeNative(0xAD738C3085FE7E11, nveh, true, true) -- set as mission entity
      	SetVehicleHasBeenOwnedByPlayer(nveh,true)
      	SetModelAsNoLongerNeeded(mhash)
		SetVehicleNumberPlateText(nveh,plate)
	  	tvRP.notify("Vehicul spawnat.")
	else
	  	tvRP.notify("Modelul vehicul invalid.")
	end
end

function tvRP.setArmour(armour,vest,first_spawn)
	if first_spawn then
		Wait(20000)
	end
	local ped = _GPED
	if vest then
  
		RequestAnimDict("clothingtie")
	  while not HasAnimDictLoaded("clothingtie") do
		  Citizen.Wait(1) 
	  end
	  TaskPlayAnim(ped, "clothingtie", "try_tie_negative_a", 3.0, 3.0, 2000, 01, 0, false, false, false)
  
		local model = GetEntityModel(ped)
  
	  if model == maleModel then
		SetPedComponentVariation(ped, 9, 6, 1, 2)
	  elseif model == femaleModel then
		SetPedComponentVariation(ped, 9, 6, 1, 2)
	  end
	end
	local n = math.floor(armour)
	SetPedArmour(ped, n)
end

function tvRP.getArmour()
	return GetPedArmour(_GPED)
end

local showblip = false

RegisterNetEvent("snTurfs:cancelBlips",function()
	showblip = false
    for _, id in ipairs(GetActivePlayers()) do
    ped = GetPlayerPed(id)
	blip = GetBlipFromEntity(ped)
    RemoveBlip(blip)
    end
end)

RegisterNetEvent("hud:setQuestions", function(v)
    SendNUIMessage({updatehud = true, cemodifica = "questions", valoare = v});
end);

function tvRP.showBlips()
	showblip = not showblip
	if showblip then
		tvRP.notify("Blip-uri Activate")
	else
		tvRP.notify("Blip-uri Dezactivate")
	end
	Citizen.CreateThread(function()
		while true do
			if showblip then
				for _, id in ipairs(GetActivePlayers()) do
					if GetPlayerPed(id) ~= _GPED then
						local ped = GetPlayerPed(id)
						local blip = GetBlipFromEntity(ped)
						-- HEAD DISPLAY STUFF --
						-- Create head display (this is safe to be spammed)
						local headId = Citizen.InvokeNative(0xBFEFE3321A3F5015, ped, GetPlayerName(id), false, false, "", false)
						local wantedLvl = GetPlayerWantedLevel(id)
						Citizen.InvokeNative(0x63BB75ABEDC1F6A0, headId, 0, true) -- Add player name sprite
						-- Wanted level display
						if wantedLvl then
							Citizen.InvokeNative(0x63BB75ABEDC1F6A0, headId, 7, true) -- Add wanted sprite
							Citizen.InvokeNative(0xCF228E2AA03099C3, headId, wantedLvl) -- Set wanted number
						else
							Citizen.InvokeNative(0x63BB75ABEDC1F6A0, headId, 7, false) -- Remove wanted sprite
						end
						-- Speaking display
						if NetworkIsPlayerTalking(id) then
							Citizen.InvokeNative(0x63BB75ABEDC1F6A0, headId, 9, true) -- Add speaking sprite
						else
							Citizen.InvokeNative(0x63BB75ABEDC1F6A0, headId, 9, false) -- Remove speaking sprite
						end
						if showblip then
							-- BLIP STUFF --
							if not DoesBlipExist(blip) then -- Add blip and create head display on player
								blip = AddBlipForEntity(ped)
								SetBlipSprite(blip, 1)
								Citizen.InvokeNative(0x5FBCA48327B914DF, blip, true) -- Player Blip indicator
							else -- update blip
								veh = GetVehiclePedIsIn(ped, false)
								blipSprite = GetBlipSprite(blip)
								if not GetEntityHealth(ped) then -- dead
									if blipSprite ~= 274 then
										SetBlipSprite(blip, 274)
										Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Player Blip indicator
									end
								elseif veh then
									vehClass = GetVehicleClass(veh)
									vehModel = GetEntityModel(veh)
									if vehClass == 15 then -- jet
										if blipSprite ~= 422 then
											SetBlipSprite(blip, 422)
											Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Player Blip indicator
										end
									elseif vehClass == 16 then -- plane
										if vehModel == GetHashKey("besra") or vehModel == GetHashKey("hydra")
											or vehModel == GetHashKey("lazer") then -- jet
											if blipSprite ~= 424 then
												SetBlipSprite(blip, 424)
												Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Player Blip indicator
											end
										elseif blipSprite ~= 423 then
											SetBlipSprite(blip, 423)
											Citizen.InvokeNative (0x5FBCA48327B914DF, blip, false) -- Player Blip indicator
										end
									elseif vehClass == 14 then -- boat
										if blipSprite ~= 427 then
											SetBlipSprite(blip, 427)
											Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Player Blip indicator
										end
									elseif vehModel == GetHashKey("insurgent") or vehModel == GetHashKey("insurgent2") or vehModel == GetHashKey("limo2") then -- insurgent (+ turreted limo cuz limo blip wont work)
										if blipSprite ~= 426 then
											SetBlipSprite(blip, 426)
											Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Player Blip indicator
										end
									elseif vehModel == GetHashKey("rhino") then -- tank
										if blipSprite ~= 421 then
											SetBlipSprite(blip, 421)
											Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Player Blip indicator
										end
									elseif blipSprite ~= 1 then -- default blip
										SetBlipSprite(blip, 1)
										Citizen.InvokeNative(0x5FBCA48327B914DF, blip, true) -- Player Blip indicator
									end
									-- Show number in case of passangers
									local passengers = GetVehicleNumberOfPassengers(veh)
									if passengers then
										if not IsVehicleSeatFree(veh, -1) then
											passengers = passengers + 1
										end
										ShowNumberOnBlip(blip, passengers)
									else
										HideNumberOnBlip(blip)
									end
								else
									-- Remove leftover number
									HideNumberOnBlip(blip)
									if blipSprite ~= 1 then -- default blip
										SetBlipSprite(blip, 1)
										Citizen.InvokeNative(0x5FBCA48327B914DF, blip, true) -- Player Blip indicator
									end
								end
								SetBlipRotation(blip, math.ceil(GetEntityHeading(veh))) -- update rotation
								SetBlipNameToPlayerName(blip, id) -- update blip name
								SetBlipScale(blip,  0.5) -- set scale
								-- set player alpha
								if IsPauseMenuActive() then
									SetBlipAlpha(blip, 255)
								else
									local x1, y1 = table.unpack(_GCOORDS, true)
									local x2, y2 = table.unpack(GetEntityCoords(GetPlayerPed(id), true))
									local distance = (math.floor(math.abs(math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2))) / -1)) + 900
									if distance < 0 then
										distance = 0
									elseif distance > 255 then
										distance = 255
									end
									SetBlipAlpha(blip, distance)
								end
							end
						end
					end
				end
			else
				for _, id in ipairs(GetActivePlayers()) do
					if GetPlayerPed(id) ~= GetPlayerPed(-1) then
						local ped = GetPlayerPed(id)
						local blip = GetBlipFromEntity(ped)
						RemoveBlip(blip)
						local headId = Citizen.InvokeNative(0xBFEFE3321A3F5015, ped, GetPlayerName(id), false, false, "", false)
						Citizen.InvokeNative( 0x63BB75ABEDC1F6A0, headId, 7, false ) -- Remove wanted sprite
						Citizen.InvokeNative( 0x63BB75ABEDC1F6A0, headId, 9, false ) -- Remove speaking sprite
						Citizen.InvokeNative( 0x63BB75ABEDC1F6A0, headId, 0, false ) -- Remove player name sprite
					end
				end
				break
			end
			Wait(0)
		end
	end)
end

-- Prone Crouch --

local crouched, proned = false, false

local crouchKey = 36
local proneKey = 20

local function SetProned()
	ped = PlayerPedId()
	ClearPedTasksImmediately(ped)
	TaskPlayAnimAdvanced(ped, "move_crawl", "onfront_fwd", _GCOORDS, 0.0, 0.0, GetEntityHeading(ped), 1.0, 1.0, 1.0, 46, 1.0, 0, 0)
end

local function ProneMovement()
	if proned then
		ped = PlayerPedId()
		if IsControlPressed(0, 32) or IsControlPressed(0, 33) then
			DisablePlayerFiring(ped, true)
		 elseif IsControlJustReleased(0, 32) or IsControlJustReleased(0, 33) then
		 	DisablePlayerFiring(ped, false)
		 end
		if IsControlJustPressed(0, 32) and not movefwd then
			movefwd = true
		    TaskPlayAnimAdvanced(ped, "move_crawl", "onfront_fwd", _GCOORDS, 1.0, 0.0, GetEntityHeading(ped), 1.0, 1.0, 1.0, 47, 1.0, 0, 0)
		elseif IsControlJustReleased(0, 32) and movefwd then
		    TaskPlayAnimAdvanced(ped, "move_crawl", "onfront_fwd", _GCOORDS, 1.0, 0.0, GetEntityHeading(ped), 1.0, 1.0, 1.0, 46, 1.0, 0, 0)
			movefwd = false
		end		
		if IsControlJustPressed(0, 33) and not movebwd then
			movebwd = true
		    TaskPlayAnimAdvanced(ped, "move_crawl", "onfront_bwd", _GCOORDS, 1.0, 0.0, GetEntityHeading(ped), 1.0, 1.0, 1.0, 47, 1.0, 0, 0)
		elseif IsControlJustReleased(0, 33) and movebwd then 
		    TaskPlayAnimAdvanced(ped, "move_crawl", "onfront_bwd", _GCOORDS, 1.0, 0.0, GetEntityHeading(ped), 1.0, 1.0, 1.0, 46, 1.0, 0, 0)
		    movebwd = false
		end
		if IsControlPressed(0, 34) then
			SetEntityHeading(ped, GetEntityHeading(ped)+2.0 )
		elseif IsControlPressed(0, 35) then
			SetEntityHeading(ped, GetEntityHeading(ped)-2.0 )
		end
	end
end

local other = nil
local drag = false
local playerStillDragged = false

RegisterNetEvent("dr:drag")
AddEventHandler('dr:drag', function(pl)
    other = pl
	drag = not drag
	Citizen.CreateThread(function()
		while true do
			if drag and other ~= nil then
				local ped = GetPlayerPed(GetPlayerFromServerId(other))
				local myped = _GPED
				AttachEntityToEntity(myped, ped, 4103, 11816, 0.54, 0.54, 0.0, 0.0, 0.0, 0.0, false, false, false, false, 2, true)
				playerStillDragged = true
			elseif playerStillDragged then
				DetachEntity(_GPED, true, false)
				playerStillDragged = false
				break
			end
			Wait(0)
		end
	end)
end)